<?php

//获取操作系统名称
function getOsName(){
	if(substr(PHP_OS,0,3)==='WIN')
		return "win";
	else
		return "linux";
}

//判断是否键值对类型的数组
function isAssocArray($array){
	if(! is_array($array) )
		return false;
	return array_keys($array) !== range(0, count($array) - 1);
}

//获取文件扩展名,小写
function getFileExt($fileName){
	return strtolower(pathinfo($fileName,PATHINFO_EXTENSION));
}

//是否压缩文件
function isZipFile($fileName){
	$fileExt = getFileExt($fileName);
	return in_array($fileExt,array("zip","7z"));
}
//获取 gopeed.exe 路径
function getGoPeedPath(){
	return dirname(dirname(__FILE__)). "/bin/gopeed.exe";
}

//获取 7z.exe 路径
function get7ZipPath(){
	return dirname(dirname(__FILE__)). "/bin/7z.exe";
}

//多线程下载文件
function downloadToDir($ossUrl,$repoName,$fileName,$targetDir){
	if (!file_exists($targetDir))
		mkdir($targetDir,0777,true);

	$targetPath = pathJoin($targetDir,$fileName);
	if( file_exists($targetPath) ) {
		return $targetPath;
	}
	$gopeed = getGoPeedPath();
	
	$remoteUrl = pathJoin($ossUrl,$repoName,$fileName);
	$cmd = $gopeed." -D=" . $targetDir . " " . $remoteUrl;
	system($cmd, $ret);
	if ($ret != 0) {
		return false;
	}
	return $targetPath;
}

//解压缩文件
function unzipFile($zipFile, $targetDir){
	$fileExt = getFileExt($zipFile);
	if($fileExt == "zip"){
		$zip= new \ZipArchive;
		if($zip->open($zipFile)==true){
			$zip->extractTo($targetDir);
			$zip->close();
			return true;
		}
		else{
			return false;
		}
	}
	if($fileExt == "7z"){
		$sevenZip = get7ZipPath();
		$logPath = $zipFile . '.7zlog';
		$cmd = $sevenZip . " x $zipFile -o$targetDir -aoa > " . $logPath;
		system($cmd, $ret);
		if ($ret != 0) {
			return false;
		}
		return true;
	}
	return false;
}
function twoPathJoin($base, $path) {
	return rtrim( $base, '/' ) . '/' . ltrim( $path, '/' );
}
function pathJoin($base, $path) {
	$newPath = twoPathJoin($base, $path);
	$args = func_get_args();
	$argc = func_num_args();
	for($i=2;$i<$argc;$i++){
		$newPath = twoPathJoin($newPath,$args[$i]);
	}
    return $newPath;
}
//过滤得到一个最终文件列表
function filterFiles($files){
	if(!is_array($files) )
		return array();
	if( isAssocArray($files) ){

		$osname = getOsName();
		return $files[$osname] ? : array();
	}
	else{
		return $files;
	}
}

//获取最上层包配置的bin-dir路径
function  getBinDir($cfgPath) {
	$data = json_decode(file_get_contents($cfgPath), true);
	$binDir = $data["composer-helper"]["bin-dir"];
	if(! $binDir){
		return "";
	}
	$osname = getOsName();
	if(isAssocArray($binDir))
		$binDir = $binDir[$osname];
	if($binDir){
		return dirname($cfgPath) . '/' . $binDir;
	}else{
		return "";
	}
}
//获取依赖包的待下载的文件列表
function getPackageFiles($cfgPath)
{
	// 解析 composer.json
	if (!file_exists($cfgPath)) {
		return false;
	}
	$data = json_decode(file_get_contents($cfgPath), true);
	if (!$data) {
		print("bad json format - " . $cfgPath . PHP_EOL);
		return false;
	}
	
	//过滤并组合得到待下载文件列表
	return array(
		'files'=>filterFiles($data["composer-helper"]["files"]),
		'bin-files'=>filterFiles($data["composer-helper"]["bin-files"])
	);
}